/*
* Petit Station 
*
* Created: 2020/5/24
* Author : TRAINO
*
*  Pin Assignment 
*    (OC0A)(TPID)PB0 1   6 PB3(RST)
*                GND 2   5 Vcc
*    (OC0B)(TPIC)PB1 3   4 PB2   
*
*  PB0 = ADC    When writing the program, make sure the slottle is in the center position.
*  PB1 = OUTA(OUT1)
*  PB2 = OUTB(OUT2)
* 
* Ver 0 2020-5-24 test version
*       2020-6-7 FIX 
*
*/
#include <avr/io.h>
#define cbi(addr,bit)     addr &= ~(1<<bit) //  clear bit@addr
#define sbi(addr,bit)     addr |=  (1<<bit) //  set bit@addr
#define sigIsHigh bit_is_set(PINB,PINB2)
#define sigIsLow bit_is_clear(PINB,PINB2)
#define ThresholdOfBlueButton 249
/*
** DCC^Pulse Delay Fuctions
*/
void wait_ms(short time) {
  for(;time!=0;time--) for(short j=0;j<200;j++) cbi(PORTB,PINB3); // set up @ 500mS at simulator
}
void wait_58usH() {  // length of HI pulse
   for(short j=0;j<9;j++) cbi(PORTB,PINB3);
}
void wait_58usL() {  // length of LO pulse
   for(short j=0;j<10;j++) cbi(PORTB,PINB3); 
} 
void wait_110us() {  // Length of zero pulse
   for(short j=0;j<24;j++) cbi(PORTB,PINB3); 
}
//
// ADC for volume input
//
unsigned char adconv(){
  cbi(ADCSRA,ADIF);                        // reset the AD conversion finished flag
  sbi(ADCSRA,ADSC);                        // start ad conversion
  loop_until_bit_is_set(ADCSRA,ADIF);      //wait conversion flag is set
  return (unsigned char)ADCL;              //return ad conv. register (8bit)
}
//
// send continuous 1 and one 0
//
void sendPriamble(signed count) {
  do {
    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH();
    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL();
  } while (--count >=0);
  // send zero
  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us();
  cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us();
}
void sendzero(signed count) {
  do {
    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us();
    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us();
  } while (--count >=0);
}
void sendData(unsigned char a,unsigned char last) {
  if(a&0x80) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else 
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x40) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x20) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ; }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x10) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x8) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x4) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x2) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  if(a&0x1) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us() ;    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us() ;
  }
  // last zero  
  if(last!=0) {sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;}
  // zero
  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_110us();cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_110us();
}
//
//
void funcControl(unsigned char adrs,unsigned char cmd) {
  sendPriamble(14);  // 1,1,1,1,1,1,1,1,,,,0
  sendData(adrs,0);    // adrs1 == 03 -> 0000 0011 & 0
  sendData(cmd,0);    // 0x80
  sendData(adrs^cmd,1); //
  sendzero(14);
}
void LEDON() { 
  PORTB = 0B00000110;  // LED on but track power is off
  wait_ms(100);
}
void LEDOFF() {
  PORTB = 0B00000000;
  wait_ms(100);
}
//
// Get one digit from slottle and blue button
//
unsigned char getadrs() {  // button is pushed when call this function
  unsigned char num,numold=0,dispnum=0;
  for(;adconv()>ThresholdOfBlueButton;) LEDON(); // wait release button 
  for(;;) {
    LEDOFF(); // turn off the LED
    num = adconv(); // Get ad conversion
    // 0 bluebutton? 
    if (num>ThresholdOfBlueButton) {
      LEDON();
      wait_ms(500);
      return numold;
    }
    // convert the angle to num
    if(num < 19) num = 0;
    else num = (num-19)/22;
    //if(num>9) num=9;
    //numold = num;

    if(num<=9) numold = num; 
    if(++dispnum <= numold) {
        LEDON();
        if(dispnum+4 <= numold) { // ５ is long 
        LEDON();
        LEDON();
        dispnum+=4;  
        }
    }
    else {
        LEDOFF();
        dispnum = 0;    
    }
    LEDOFF();
} }
//
// Program starts here
//
int main(void) {
  unsigned char address=0,cmd3=0x80,lastad=0x80,ad_data; 
  DDRB= 0B00000110;   // PB0 = volume ,PB1,PB2=output port
  DIDR0 = 0B01;       //  disable digital input for AD conversion
  ADCSRA= 0b10000111; // permit AD conv, clock = 1/128 clock
  // ADMUX =0;      // MUX = B0 (default setting)

  // wait Blue button
  wait_ms(100);
  for(;adconv()<ThresholdOfBlueButton;);   // wait pussed buttion 

  // Select start mode
  for(unsigned char cc=0;cc<100;cc++) {  // address is counter in this function
    if(adconv()<ThresholdOfBlueButton) { address =3;break;}  // loco address = 3 within short time
    wait_ms(10);
  }
  if(address!=3) { // time is over ?
      address=getadrs()*10+getadrs(); // get double digit (1-99)
      for(;adconv()>ThresholdOfBlueButton;); // wait button release
      wait_ms(100);
  }

  // wait slotle is center position
  for(;adconv()<0x70;){LEDON();LEDOFF();}; 
  for(;adconv()>0x90;){LEDON();LEDOFF();};
  //
  // Send DCC power
  //  
  for(;;) {
    funcControl(address,0B10010001); // 0b100ddddd ,F1 on F2 = off
    ad_data = adconv();
    if(ad_data>=ThresholdOfBlueButton) { // When button is pushed, keep F2 ON
      for(;ad_data>=ThresholdOfBlueButton ; ad_data = adconv()) {
        funcControl(address,0B10010011); // 0b100ddddd F2 = on
        //speedControl(address,lastad);
        // ad_data = adconv();
      } // while (ad_data>=ThresholdOfBlueButton);
    }
    else
      lastad=ad_data;
    //
    // Send speedstep
    //  lastad
    //  0-0x37    rev2
    //  0x38-0x69 rev
    //  0x70-0x90 stop
    //  0x90-0xc7 FWD
    //  0xc8-0xff FWD2 
    //
    cmd3 = lastad & 0x80;  // MSB means FWD
    // 0-50%(64cnt)
    //
    if(lastad>144/*0x90*/) cmd3 = lastad - 0x90 + 0x80; // FWD
    //
    //  50% -90%
    //
    if(lastad>144+64) cmd3 += lastad - 144 - 64;
    // AD 0x90 + 64 + 32 (232)
    // 100 % 
    if(lastad>144+64+26) cmd3 = 0xff; // 2020-6-7 32=>26

    // reverse
    if(lastad<0x70) cmd3 = 0x70 - lastad;  //BACK
    if(lastad<0x70-64) cmd3 +=  0x70- 64 - lastad;  //BACK
    if(lastad<0X70-64-26) cmd3 = 0x7f;  // 2020-6-7cliamp 90% 32=> 26
        
    //
    if((cmd3 & 0x7f)==0x01) cmd3 &= 0xFE; // speed step 1 means emergency stop => forced 0
    //
    // send speed control
    //
    sendPriamble(14); // 1,1,1,1,1,1,1,1,,,,0
    sendData(address,0); // adrs1 == 03 -> 0000 0011 & 0
    sendData(0x3F,0); // 3F  = 128 step
    sendData(cmd3,0); // 0x80
    sendData(address^0x3f^cmd3,1);  //  send ex-or checksum
    sendzero(14);
}  }
// End of file
